import { PrivilegeMap } from '../../privilege/types';
import { Group, App } from '../../principal/types';
import { HalResource } from 'hal-types';
export declare function collection(apps: App[]): HalResource;
/**
 * Generate a HAL response for a specific app
 *
 * hasControl should only be true if the *current* user is same as the user
 * we're generating the repsonse for, or if the current authenticated user
 * has full admin privileges
 */
export declare function item(app: App, privileges: PrivilegeMap, isAdmin: boolean, groups: Group[]): HalResource;
