"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = require("@curveball/controller");
const service_1 = require("../log/service");
const types_1 = require("../log/types");
const UserService = require("../user/service");
const html_1 = require("./formats/html");
class ChangePasswordController extends controller_1.default {
    async get(ctx) {
        ctx.response.type = 'text/html';
        ctx.response.body = html_1.changePasswordForm(ctx.query.msg, ctx.query.error);
    }
    async post(ctx) {
        const user = ctx.session.user;
        const currentPassword = ctx.request.body.currentPassword;
        const userNewPassword = ctx.request.body.newPassword;
        const confirmNewPassword = ctx.request.body.confirmNewPassword;
        if (!await UserService.validatePassword(user, currentPassword)) {
            ctx.status = 303;
            ctx.response.headers.set('Location', '/changepassword?error=Current+password+isn\'t+correct.+Please+try+again');
            return;
        }
        if (currentPassword === userNewPassword) {
            ctx.status = 303;
            ctx.response.headers.set('Location', '/changepassword?error=New+password+and+old+password+can\'t+be+the+same.+Please+try+again');
            return;
        }
        if (userNewPassword !== confirmNewPassword) {
            ctx.status = 303;
            ctx.response.headers.set('Location', '/changepassword?error=New+password+mismatch.+Please+try+again');
            return;
        }
        await UserService.updatePassword(user, userNewPassword);
        ctx.session = {
            user: user,
        };
        service_1.default(types_1.EventType.changePasswordSuccess, ctx);
        ctx.status = 303;
        ctx.response.headers.set('Location', '/');
    }
}
exports.default = new ChangePasswordController();
//# sourceMappingURL=controller.js.map