"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = require("@curveball/controller");
const hal_1 = require("./formats/hal");
const markdown_1 = require("./formats/markdown");
const privilegeService = require("../privilege/service");
const service_1 = require("./service");
// eslint-disable-next-line @typescript-eslint/no-var-requires
const version = require('../../package.json').version;
class HomeController extends controller_1.default {
    async getMd(ctx) {
        const user = ctx.state.user;
        const isAdmin = await privilegeService.hasPrivilege(user, 'admin', '*');
        const stats = await service_1.getServerStats();
        ctx.response.type = 'text/markdown';
        ctx.response.headers.set('Title', 'Home');
        ctx.response.headers.append('Link', [
            '</>; rel="alternate"; type="application/hal+json"',
            '</logout>; rel="logout"',
            `</user/${user.id}>; rel="authenticated-as" title="${user.nickname.replace('"', '')}"`,
        ]);
        ctx.response.body = markdown_1.default(version, user, isAdmin, stats);
    }
    async getJson(ctx) {
        const user = ctx.state.user;
        const isAdmin = await privilegeService.hasPrivilege(user, 'admin', '*');
        const stats = await service_1.getServerStats();
        ctx.response.headers.append('Link', [
            '</>; rel="alternate"; type="text/markdown"',
        ]);
        ctx.response.body = hal_1.default(version, user, isAdmin, stats);
    }
}
__decorate([
    controller_1.method('GET'),
    controller_1.accept('markdown')
], HomeController.prototype, "getMd", null);
__decorate([
    controller_1.method('GET'),
    controller_1.accept('application/hal+json')
], HomeController.prototype, "getJson", null);
exports.default = new HomeController();
//# sourceMappingURL=controller.js.map