"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inactive = exports.refreshToken = exports.accessToken = void 0;
const url = require("url");
function accessToken(token, privileges) {
    return {
        active: true,
        scope: Object.values(privileges).join(' '),
        privileges: privileges,
        client_id: token.clientId,
        username: token.user.nickname,
        token_type: 'bearer',
        exp: token.accessTokenExpires,
        _links: {
            'authenticated-as': {
                href: url.resolve(process.env.PUBLIC_URI, '/user/' + token.user.id),
            }
        }
    };
}
exports.accessToken = accessToken;
function refreshToken(token, privileges) {
    return {
        active: true,
        scope: Object.values(privileges).join(' '),
        privileges: privileges,
        client_id: token.clientId,
        username: token.user.nickname,
        token_type: 'refresh_token',
        _links: {
            'authenticated-as': {
                href: url.resolve(process.env.PUBLIC_URI, '/user/' + token.user.id),
            }
        }
    };
}
exports.refreshToken = refreshToken;
function inactive() {
    return {
        active: false
    };
}
exports.inactive = inactive;
//# sourceMappingURL=json.js.map