"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findByUser = exports.addLogEntry = void 0;
const database_1 = require("../database");
const geoip = require("geoip-lite");
async function log(eventType, arg1, arg2, arg3) {
    var _a, _b;
    if (isContext(arg1)) {
        await addLogEntry(eventType, arg1.ip(), (_b = (_a = arg1.session.user) === null || _a === void 0 ? void 0 : _a.id) !== null && _b !== void 0 ? _b : null, arg1.request.headers.get('User-Agent'));
    }
    else {
        await addLogEntry(eventType, arg1, arg2, arg3);
    }
}
exports.default = log;
async function addLogEntry(eventType, ip, userId, userAgent) {
    await database_1.default.query('INSERT INTO user_log SET time = UNIX_TIMESTAMP(), ?', {
        user_id: userId,
        event_type: eventType,
        ip: ip,
        user_agent: userAgent,
        country: ip ? getCountryByIp(ip) : null,
    });
}
exports.addLogEntry = addLogEntry;
async function findByUser(user) {
    const result = await database_1.default.query('SELECT * FROM user_log WHERE user_id = ?', [user.id]);
    return result[0].map((row) => {
        return {
            time: new Date(row.time * 1000),
            ip: row.ip,
            eventType: row.event_type,
            userAgent: row.user_agent,
            country: row.country
        };
    });
}
exports.findByUser = findByUser;
function isContext(ctx) {
    return ctx.ip !== undefined;
}
function getCountryByIp(ip) {
    var _a;
    return (_a = geoip.lookup(ip)) === null || _a === void 0 ? void 0 : _a.country;
}
//# sourceMappingURL=service.js.map