"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = require("@curveball/controller");
const html_1 = require("./formats/html");
const oauth2Service = require("../oauth2/service");
class LogoutController extends controller_1.default {
    get(ctx) {
        ctx.response.type = 'text/html';
        ctx.response.body = html_1.logoutForm(ctx.query.msg, ctx.query.error, ctx.query.continue);
    }
    async post(ctx) {
        await oauth2Service.invalidateTokensByBrowserSessionId(ctx.sessionId);
        ctx.session = {};
        ctx.sessionId = null;
        ctx.status = 303;
        ctx.redirect(303, ctx.request.body.continue || '/');
    }
}
exports.default = new LogoutController();
//# sourceMappingURL=controller.js.map