"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.save = exports.generateSecret = void 0;
const otplib_1 = require("otplib");
const database_1 = require("../../database");
function generateSecret() {
    const secret = otplib_1.authenticator.generateSecret();
    return secret;
}
exports.generateSecret = generateSecret;
async function save(totpDevice) {
    const query = 'INSERT INTO user_totp SET ?, created = UNIX_TIMESTAMP()';
    const newTotpDeviceRecord = {
        user_id: totpDevice.user.id,
        secret: totpDevice.secret,
    };
    const result = await database_1.default.query(query, [newTotpDeviceRecord]);
    return {
        id: result[0].insertId,
        'failures': 0,
        ...totpDevice,
    };
}
exports.save = save;
//# sourceMappingURL=service.js.map