"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = require("@curveball/controller");
const privilegeService = require("../../privilege/service");
const siren = require("../formats/siren");
const http_errors_1 = require("@curveball/http-errors");
const principalService = require("../../principal/service");
class NewClientController extends controller_1.default {
    async get(ctx) {
        const user = await principalService.findById(+ctx.params.id, 'app');
        if (!await privilegeService.hasPrivilege(ctx, 'admin')) {
            throw new http_errors_1.Forbidden('Only users with the "admin" privilege can add new OAuth2 clients');
        }
        ctx.response.type = 'application/vnd.siren+json';
        ctx.response.body = siren.newClient(user);
    }
}
exports.default = new NewClientController();
//# sourceMappingURL=new.js.map