"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function parseBasic(ctx) {
    const authHeader = ctx.request.headers.get('Authorization');
    if (!authHeader) {
        return null;
    }
    const parts = authHeader.split(' ', 2);
    if (parts.length < 2 || parts[0].toLowerCase() !== 'basic') {
        return null;
    }
    const decoded = Buffer.from(parts[1], 'base64').toString().split(':', 2);
    if (decoded.length < 2) {
        return null;
    }
    return decoded;
}
exports.default = parseBasic;
//# sourceMappingURL=parse-basic-auth.js.map