"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = require("@curveball/controller");
const service_1 = require("../../log/service");
const types_1 = require("../../log/types");
const service_2 = require("../service");
const service_3 = require("../../oauth2-client/service");
class RevokeController extends controller_1.default {
    async post(ctx) {
        let oauth2Client;
        if (ctx.request.headers.has('Authorization')) {
            oauth2Client = await service_3.getOAuth2ClientFromBasicAuth(ctx);
        }
        else {
            oauth2Client = await service_3.getOAuth2ClientFromBody(ctx);
        }
        const token = ctx.request.body.token;
        await service_2.revokeByAccessRefreshToken(oauth2Client, token);
        service_1.default(types_1.EventType.tokenRevoked, ctx);
        ctx.status = 200;
    }
}
exports.default = new RevokeController();
//# sourceMappingURL=revoke.js.map