"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors_1 = require("./errors");
const oauth2ErrorHandler = async (ctx, next) => {
    try {
        await next();
    }
    catch (err) {
        if (errors_1.isOAuth2Error(err)) {
            /* eslint-disable-next-line no-console */
            console.log(err);
            ctx.status = err.httpStatus;
            ctx.response.type = 'application/json';
            ctx.response.body = {
                error: err.errorCode,
                error_description: err.message,
            };
        }
        else {
            // Let someone else deal with it
            throw err;
        }
    }
};
exports.default = oauth2ErrorHandler;
//# sourceMappingURL=oauth2-error-handler.js.map