export declare type Principal = User | Group | App;
export declare type NewPrincipal = Omit<Principal, 'id' | 'href'>;
export declare type PrincipalType = 'user' | 'app' | 'group';
export declare const PrincipalTypeList: PrincipalType[];
export declare type User = {
    id: number;
    href: string;
    type: 'user';
    identity: string;
    nickname: string;
    createdAt: Date;
    modifiedAt: Date;
    active: boolean;
};
export declare type Group = {
    id: number;
    href: string;
    type: 'group';
    identity: string;
    nickname: string;
    createdAt: Date;
    modifiedAt: Date;
    active: boolean;
};
export declare type App = {
    id: number;
    href: string;
    type: 'app';
    identity: string;
    nickname: string;
    createdAt: Date;
    modifiedAt: Date;
    active: boolean;
};
export declare type PrincipalStats = {
    user: number;
    app: number;
    group: number;
};
