"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = require("@curveball/controller");
const http_errors_1 = require("@curveball/http-errors");
const redirect_1 = require("../formats/redirect");
const service_1 = require("../../one-time-token/service");
/**
 * This controller is used for validating token and rendering reset password form.
 *
 * After a user gets redirected from the reset password request email,
 * the controller will check if the provided token is validated it will render the
 * reset password form.
 */
class ResetPasswordTokenController extends controller_1.default {
    async get(ctx) {
        const urlToken = ctx.params.token;
        const user = await service_1.validateToken(urlToken);
        ctx.session.resetPasswordUser = user;
        if (!ctx.session.resetPasswordUser) {
            throw new http_errors_1.Forbidden('You can only use this endpoint after you went through the \'forgot password\' flow');
        }
        ctx.response.type = 'text/html';
        ctx.response.body = redirect_1.resetPasswordForm(ctx.query.msg, ctx.query.error);
    }
}
exports.default = new ResetPasswordTokenController();
//# sourceMappingURL=token.js.map