declare type Settings = {
    'cors.allowOrigin': string[] | null;
    'oauth2.code.expiry': number;
    'oauth2.accessToken.expiry': number;
    'oauth2.refreshToken.expiry': number;
    'registration.enabled': boolean;
    'registration.mfa.enabled': boolean;
    'totp': 'enabled' | 'required' | 'disabled';
    'totp.serviceName': string;
    'webauthn': 'enabled' | 'disabled' | 'required';
    'webauthn.expectedOrigin': string;
    'webauthn.relyingPartyId': string;
    'webauthn.serviceName': string;
    'login.defaultRedirect': string;
};
export declare function getSetting<T extends keyof Settings>(setting: T, deflt?: Settings[T]): Settings[T];
/**
 * Loads or reloads settings from the database.
 */
export declare function load(): Promise<void>;
export {};
